<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/ahash-0.7.6/src/fallback_hash.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>fallback_hash.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../source-script.js"></script><script defer src="../../source-files.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../ahash/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../ahash/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../ahash/index.html"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
<span id="192">192</span>
<span id="193">193</span>
<span id="194">194</span>
<span id="195">195</span>
<span id="196">196</span>
<span id="197">197</span>
<span id="198">198</span>
<span id="199">199</span>
<span id="200">200</span>
<span id="201">201</span>
<span id="202">202</span>
<span id="203">203</span>
<span id="204">204</span>
<span id="205">205</span>
<span id="206">206</span>
<span id="207">207</span>
<span id="208">208</span>
<span id="209">209</span>
<span id="210">210</span>
<span id="211">211</span>
<span id="212">212</span>
<span id="213">213</span>
<span id="214">214</span>
<span id="215">215</span>
<span id="216">216</span>
<span id="217">217</span>
<span id="218">218</span>
<span id="219">219</span>
<span id="220">220</span>
<span id="221">221</span>
<span id="222">222</span>
<span id="223">223</span>
<span id="224">224</span>
<span id="225">225</span>
<span id="226">226</span>
<span id="227">227</span>
<span id="228">228</span>
<span id="229">229</span>
<span id="230">230</span>
<span id="231">231</span>
<span id="232">232</span>
<span id="233">233</span>
<span id="234">234</span>
<span id="235">235</span>
<span id="236">236</span>
<span id="237">237</span>
<span id="238">238</span>
<span id="239">239</span>
<span id="240">240</span>
<span id="241">241</span>
<span id="242">242</span>
<span id="243">243</span>
<span id="244">244</span>
<span id="245">245</span>
<span id="246">246</span>
<span id="247">247</span>
<span id="248">248</span>
<span id="249">249</span>
<span id="250">250</span>
<span id="251">251</span>
<span id="252">252</span>
<span id="253">253</span>
<span id="254">254</span>
<span id="255">255</span>
<span id="256">256</span>
<span id="257">257</span>
<span id="258">258</span>
<span id="259">259</span>
<span id="260">260</span>
<span id="261">261</span>
<span id="262">262</span>
<span id="263">263</span>
<span id="264">264</span>
<span id="265">265</span>
<span id="266">266</span>
<span id="267">267</span>
<span id="268">268</span>
<span id="269">269</span>
<span id="270">270</span>
<span id="271">271</span>
<span id="272">272</span>
<span id="273">273</span>
<span id="274">274</span>
<span id="275">275</span>
<span id="276">276</span>
<span id="277">277</span>
<span id="278">278</span>
<span id="279">279</span>
<span id="280">280</span>
<span id="281">281</span>
<span id="282">282</span>
<span id="283">283</span>
<span id="284">284</span>
<span id="285">285</span>
<span id="286">286</span>
<span id="287">287</span>
<span id="288">288</span>
<span id="289">289</span>
<span id="290">290</span>
<span id="291">291</span>
<span id="292">292</span>
<span id="293">293</span>
<span id="294">294</span>
<span id="295">295</span>
<span id="296">296</span>
<span id="297">297</span>
<span id="298">298</span>
<span id="299">299</span>
<span id="300">300</span>
<span id="301">301</span>
<span id="302">302</span>
<span id="303">303</span>
<span id="304">304</span>
<span id="305">305</span>
<span id="306">306</span>
<span id="307">307</span>
<span id="308">308</span>
<span id="309">309</span>
<span id="310">310</span>
<span id="311">311</span>
<span id="312">312</span>
<span id="313">313</span>
<span id="314">314</span>
<span id="315">315</span>
<span id="316">316</span>
<span id="317">317</span>
<span id="318">318</span>
<span id="319">319</span>
<span id="320">320</span>
<span id="321">321</span>
<span id="322">322</span>
<span id="323">323</span>
<span id="324">324</span>
<span id="325">325</span>
<span id="326">326</span>
<span id="327">327</span>
<span id="328">328</span>
<span id="329">329</span>
<span id="330">330</span>
<span id="331">331</span>
<span id="332">332</span>
<span id="333">333</span>
<span id="334">334</span>
<span id="335">335</span>
<span id="336">336</span>
<span id="337">337</span>
<span id="338">338</span>
<span id="339">339</span>
<span id="340">340</span>
<span id="341">341</span>
<span id="342">342</span>
<span id="343">343</span>
<span id="344">344</span>
<span id="345">345</span>
<span id="346">346</span>
<span id="347">347</span>
<span id="348">348</span>
<span id="349">349</span>
<span id="350">350</span>
<span id="351">351</span>
<span id="352">352</span>
<span id="353">353</span>
<span id="354">354</span>
<span id="355">355</span>
<span id="356">356</span>
<span id="357">357</span>
<span id="358">358</span>
<span id="359">359</span>
<span id="360">360</span>
<span id="361">361</span>
<span id="362">362</span>
<span id="363">363</span>
<span id="364">364</span>
<span id="365">365</span>
<span id="366">366</span>
<span id="367">367</span>
<span id="368">368</span>
<span id="369">369</span>
<span id="370">370</span>
<span id="371">371</span>
<span id="372">372</span>
<span id="373">373</span>
<span id="374">374</span>
<span id="375">375</span>
<span id="376">376</span>
<span id="377">377</span>
<span id="378">378</span>
<span id="379">379</span>
<span id="380">380</span>
<span id="381">381</span>
<span id="382">382</span>
<span id="383">383</span>
<span id="384">384</span>
<span id="385">385</span>
<span id="386">386</span>
<span id="387">387</span>
<span id="388">388</span>
<span id="389">389</span>
<span id="390">390</span>
<span id="391">391</span>
<span id="392">392</span>
</pre><pre class="rust"><code><span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::convert</span>::<span class="kw-2">*</span>;
<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::operations::folded_multiply</span>;
<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::operations::read_small</span>;
<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::random_state::PI</span>;
<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::RandomState</span>;
<span class="kw">use</span> <span class="ident">core::hash::Hasher</span>;

<span class="doccomment">///This constant come from Kunth&#39;s prng (Empirically it works better than those from splitmix32).</span>
<span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">const</span> <span class="ident">MULTIPLE</span>: <span class="ident">u64</span> <span class="op">=</span> <span class="number">6364136223846793005</span>;
<span class="kw">const</span> <span class="ident">ROT</span>: <span class="ident">u32</span> <span class="op">=</span> <span class="number">23</span>; <span class="comment">//17</span>

<span class="doccomment">/// A `Hasher` for hashing an arbitrary stream of bytes.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Instances of [`AHasher`] represent state that is updated while hashing data.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Each method updates the internal state based on the new data provided. Once</span>
<span class="doccomment">/// all of the data has been provided, the resulting hash can be obtained by calling</span>
<span class="doccomment">/// `finish()`</span>
<span class="doccomment">///</span>
<span class="doccomment">/// [Clone] is also provided in case you wish to calculate hashes for two different items that</span>
<span class="doccomment">/// start with the same data.</span>
<span class="doccomment">///</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">AHasher</span> {
    <span class="ident">buffer</span>: <span class="ident">u64</span>,
    <span class="ident">pad</span>: <span class="ident">u64</span>,
    <span class="ident">extra_keys</span>: [<span class="ident">u64</span>; <span class="number">2</span>],
}

<span class="kw">impl</span> <span class="ident">AHasher</span> {
    <span class="doccomment">/// Creates a new hasher keyed to the provided key.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="attribute">#[<span class="ident">allow</span>(<span class="ident">dead_code</span>)]</span> <span class="comment">// Is not called if non-fallback hash is used.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">new_with_keys</span>(<span class="ident">key1</span>: <span class="ident">u128</span>, <span class="ident">key2</span>: <span class="ident">u128</span>) -&gt; <span class="ident">AHasher</span> {
        <span class="kw">let</span> <span class="ident">pi</span>: [<span class="ident">u128</span>; <span class="number">2</span>] <span class="op">=</span> <span class="ident">PI</span>.<span class="ident">convert</span>();
        <span class="kw">let</span> <span class="ident">key1</span>: [<span class="ident">u64</span>; <span class="number">2</span>] <span class="op">=</span> (<span class="ident">key1</span> <span class="op">^</span> <span class="ident">pi</span>[<span class="number">0</span>]).<span class="ident">convert</span>();
        <span class="kw">let</span> <span class="ident">key2</span>: [<span class="ident">u64</span>; <span class="number">2</span>] <span class="op">=</span> (<span class="ident">key2</span> <span class="op">^</span> <span class="ident">pi</span>[<span class="number">1</span>]).<span class="ident">convert</span>();
        <span class="ident">AHasher</span> {
            <span class="ident">buffer</span>: <span class="ident">key1</span>[<span class="number">0</span>],
            <span class="ident">pad</span>: <span class="ident">key1</span>[<span class="number">1</span>],
            <span class="ident">extra_keys</span>: <span class="ident">key2</span>,
        }
    }

    <span class="attribute">#[<span class="ident">allow</span>(<span class="ident">unused</span>)]</span> <span class="comment">// False positive</span>
    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">fn</span> <span class="ident">test_with_keys</span>(<span class="ident">key1</span>: <span class="ident">u128</span>, <span class="ident">key2</span>: <span class="ident">u128</span>) -&gt; <span class="self">Self</span> {
        <span class="kw">let</span> <span class="ident">key1</span>: [<span class="ident">u64</span>; <span class="number">2</span>] <span class="op">=</span> <span class="ident">key1</span>.<span class="ident">convert</span>();
        <span class="kw">let</span> <span class="ident">key2</span>: [<span class="ident">u64</span>; <span class="number">2</span>] <span class="op">=</span> <span class="ident">key2</span>.<span class="ident">convert</span>();
        <span class="self">Self</span> {
            <span class="ident">buffer</span>: <span class="ident">key1</span>[<span class="number">0</span>],
            <span class="ident">pad</span>: <span class="ident">key1</span>[<span class="number">1</span>],
            <span class="ident">extra_keys</span>: <span class="ident">key2</span>,
        }
    }

    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="attribute">#[<span class="ident">allow</span>(<span class="ident">dead_code</span>)]</span> <span class="comment">// Is not called if non-fallback hash is used.</span>
    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">fn</span> <span class="ident">from_random_state</span>(<span class="ident">rand_state</span>: <span class="kw-2">&amp;</span><span class="ident">RandomState</span>) -&gt; <span class="ident">AHasher</span> {
        <span class="ident">AHasher</span> {
            <span class="ident">buffer</span>: <span class="ident">rand_state</span>.<span class="ident">k0</span>,
            <span class="ident">pad</span>: <span class="ident">rand_state</span>.<span class="ident">k1</span>,
            <span class="ident">extra_keys</span>: [<span class="ident">rand_state</span>.<span class="ident">k2</span>, <span class="ident">rand_state</span>.<span class="ident">k3</span>],
        }
    }

    <span class="doccomment">/// This update function has the goal of updating the buffer with a single multiply</span>
    <span class="doccomment">/// FxHash does this but is vulnerable to attack. To avoid this input needs to be masked to with an</span>
    <span class="doccomment">/// unpredictable value. Other hashes such as murmurhash have taken this approach but were found vulnerable</span>
    <span class="doccomment">/// to attack. The attack was based on the idea of reversing the pre-mixing (Which is necessarily</span>
    <span class="doccomment">/// reversible otherwise bits would be lost) then placing a difference in the highest bit before the</span>
    <span class="doccomment">/// multiply used to mix the data. Because a multiply can never affect the bits to the right of it, a</span>
    <span class="doccomment">/// subsequent update that also differed in this bit could result in a predictable collision.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This version avoids this vulnerability while still only using a single multiply. It takes advantage</span>
    <span class="doccomment">/// of the fact that when a 64 bit multiply is performed the upper 64 bits are usually computed and thrown</span>
    <span class="doccomment">/// away. Instead it creates two 128 bit values where the upper 64 bits are zeros and multiplies them.</span>
    <span class="doccomment">/// (The compiler is smart enough to turn this into a 64 bit multiplication in the assembly)</span>
    <span class="doccomment">/// Then the upper bits are xored with the lower bits to produce a single 64 bit result.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// To understand why this is a good scrambling function it helps to understand multiply-with-carry PRNGs:</span>
    <span class="doccomment">/// https://en.wikipedia.org/wiki/Multiply-with-carry_pseudorandom_number_generator</span>
    <span class="doccomment">/// If the multiple is chosen well, this creates a long period, decent quality PRNG.</span>
    <span class="doccomment">/// Notice that this function is equivalent to this except the `buffer`/`state` is being xored with each</span>
    <span class="doccomment">/// new block of data. In the event that data is all zeros, it is exactly equivalent to a MWC PRNG.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This is impervious to attack because every bit buffer at the end is dependent on every bit in</span>
    <span class="doccomment">/// `new_data ^ buffer`. For example suppose two inputs differed in only the 5th bit. Then when the</span>
    <span class="doccomment">/// multiplication is performed the `result` will differ in bits 5-69. More specifically it will differ by</span>
    <span class="doccomment">/// 2^5 * MULTIPLE. However in the next step bits 65-128 are turned into a separate 64 bit value. So the</span>
    <span class="doccomment">/// differing bits will be in the lower 6 bits of this value. The two intermediate values that differ in</span>
    <span class="doccomment">/// bits 5-63 and in bits 0-5 respectively get added together. Producing an output that differs in every</span>
    <span class="doccomment">/// bit. The addition carries in the multiplication and at the end additionally mean that the even if an</span>
    <span class="doccomment">/// attacker somehow knew part of (but not all) the contents of the buffer before hand,</span>
    <span class="doccomment">/// they would not be able to predict any of the bits in the buffer at the end.</span>
    <span class="attribute">#[<span class="ident">inline</span>(<span class="ident">always</span>)]</span>
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;folded_multiply&quot;</span>)]</span>
    <span class="kw">fn</span> <span class="ident">update</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">new_data</span>: <span class="ident">u64</span>) {
        <span class="self">self</span>.<span class="ident">buffer</span> <span class="op">=</span> <span class="ident">folded_multiply</span>(<span class="ident">new_data</span> <span class="op">^</span> <span class="self">self</span>.<span class="ident">buffer</span>, <span class="ident">MULTIPLE</span>);
    }

    <span class="attribute">#[<span class="ident">inline</span>(<span class="ident">always</span>)]</span>
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">not</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;folded_multiply&quot;</span>))]</span>
    <span class="kw">fn</span> <span class="ident">update</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">new_data</span>: <span class="ident">u64</span>) {
        <span class="kw">let</span> <span class="ident">d1</span> <span class="op">=</span> (<span class="ident">new_data</span> <span class="op">^</span> <span class="self">self</span>.<span class="ident">buffer</span>).<span class="ident">wrapping_mul</span>(<span class="ident">MULTIPLE</span>);
        <span class="self">self</span>.<span class="ident">pad</span> <span class="op">=</span> (<span class="self">self</span>.<span class="ident">pad</span> <span class="op">^</span> <span class="ident">d1</span>).<span class="ident">rotate_left</span>(<span class="number">8</span>).<span class="ident">wrapping_mul</span>(<span class="ident">MULTIPLE</span>);
        <span class="self">self</span>.<span class="ident">buffer</span> <span class="op">=</span> (<span class="self">self</span>.<span class="ident">buffer</span> <span class="op">^</span> <span class="self">self</span>.<span class="ident">pad</span>).<span class="ident">rotate_left</span>(<span class="number">24</span>);
    }

    <span class="doccomment">/// Similar to the above this function performs an update using a &quot;folded multiply&quot;.</span>
    <span class="doccomment">/// However it takes in 128 bits of data instead of 64. Both halves must be masked.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This makes it impossible for an attacker to place a single bit difference between</span>
    <span class="doccomment">/// two blocks so as to cancel each other.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// However this is not sufficient. to prevent (a,b) from hashing the same as (b,a) the buffer itself must</span>
    <span class="doccomment">/// be updated between calls in a way that does not commute. To achieve this XOR and Rotate are used.</span>
    <span class="doccomment">/// Add followed by xor is not the same as xor followed by add, and rotate ensures that the same out bits</span>
    <span class="doccomment">/// can&#39;t be changed by the same set of input bits. To cancel this sequence with subsequent input would require</span>
    <span class="doccomment">/// knowing the keys.</span>
    <span class="attribute">#[<span class="ident">inline</span>(<span class="ident">always</span>)]</span>
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;folded_multiply&quot;</span>)]</span>
    <span class="kw">fn</span> <span class="ident">large_update</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">new_data</span>: <span class="ident">u128</span>) {
        <span class="kw">let</span> <span class="ident">block</span>: [<span class="ident">u64</span>; <span class="number">2</span>] <span class="op">=</span> <span class="ident">new_data</span>.<span class="ident">convert</span>();
        <span class="kw">let</span> <span class="ident">combined</span> <span class="op">=</span> <span class="ident">folded_multiply</span>(<span class="ident">block</span>[<span class="number">0</span>] <span class="op">^</span> <span class="self">self</span>.<span class="ident">extra_keys</span>[<span class="number">0</span>], <span class="ident">block</span>[<span class="number">1</span>] <span class="op">^</span> <span class="self">self</span>.<span class="ident">extra_keys</span>[<span class="number">1</span>]);
        <span class="self">self</span>.<span class="ident">buffer</span> <span class="op">=</span> (<span class="self">self</span>.<span class="ident">buffer</span>.<span class="ident">wrapping_add</span>(<span class="self">self</span>.<span class="ident">pad</span>) <span class="op">^</span> <span class="ident">combined</span>).<span class="ident">rotate_left</span>(<span class="ident">ROT</span>);
    }

    <span class="attribute">#[<span class="ident">inline</span>(<span class="ident">always</span>)]</span>
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">not</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;folded_multiply&quot;</span>))]</span>
    <span class="kw">fn</span> <span class="ident">large_update</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">new_data</span>: <span class="ident">u128</span>) {
        <span class="kw">let</span> <span class="ident">block</span>: [<span class="ident">u64</span>; <span class="number">2</span>] <span class="op">=</span> <span class="ident">new_data</span>.<span class="ident">convert</span>();
        <span class="self">self</span>.<span class="ident">update</span>(<span class="ident">block</span>[<span class="number">0</span>] <span class="op">^</span> <span class="self">self</span>.<span class="ident">extra_keys</span>[<span class="number">0</span>]);
        <span class="self">self</span>.<span class="ident">update</span>(<span class="ident">block</span>[<span class="number">1</span>] <span class="op">^</span> <span class="self">self</span>.<span class="ident">extra_keys</span>[<span class="number">1</span>]);
    }

    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;specialize&quot;</span>)]</span>
    <span class="kw">fn</span> <span class="ident">short_finish</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">u64</span> {
        <span class="self">self</span>.<span class="ident">buffer</span>.<span class="ident">wrapping_add</span>(<span class="self">self</span>.<span class="ident">pad</span>)
    }
}

<span class="doccomment">/// Provides [Hasher] methods to hash all of the primitive types.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// [Hasher]: core::hash::Hasher</span>
<span class="kw">impl</span> <span class="ident">Hasher</span> <span class="kw">for</span> <span class="ident">AHasher</span> {
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">write_u8</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">i</span>: <span class="ident">u8</span>) {
        <span class="self">self</span>.<span class="ident">update</span>(<span class="ident">i</span> <span class="kw">as</span> <span class="ident">u64</span>);
    }

    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">write_u16</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">i</span>: <span class="ident">u16</span>) {
        <span class="self">self</span>.<span class="ident">update</span>(<span class="ident">i</span> <span class="kw">as</span> <span class="ident">u64</span>);
    }

    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">write_u32</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">i</span>: <span class="ident">u32</span>) {
        <span class="self">self</span>.<span class="ident">update</span>(<span class="ident">i</span> <span class="kw">as</span> <span class="ident">u64</span>);
    }

    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">write_u64</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">i</span>: <span class="ident">u64</span>) {
        <span class="self">self</span>.<span class="ident">update</span>(<span class="ident">i</span> <span class="kw">as</span> <span class="ident">u64</span>);
    }

    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">write_u128</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">i</span>: <span class="ident">u128</span>) {
        <span class="self">self</span>.<span class="ident">large_update</span>(<span class="ident">i</span>);
    }

    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">any</span>(<span class="ident">target_pointer_width</span> <span class="op">=</span> <span class="string">&quot;64&quot;</span>, <span class="ident">target_pointer_width</span> <span class="op">=</span> <span class="string">&quot;32&quot;</span>, <span class="ident">target_pointer_width</span> <span class="op">=</span> <span class="string">&quot;16&quot;</span>))]</span>
    <span class="kw">fn</span> <span class="ident">write_usize</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">i</span>: <span class="ident">usize</span>) {
        <span class="self">self</span>.<span class="ident">write_u64</span>(<span class="ident">i</span> <span class="kw">as</span> <span class="ident">u64</span>);
    }

    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">target_pointer_width</span> <span class="op">=</span> <span class="string">&quot;128&quot;</span>)]</span>
    <span class="kw">fn</span> <span class="ident">write_usize</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">i</span>: <span class="ident">usize</span>) {
        <span class="self">self</span>.<span class="ident">write_u128</span>(<span class="ident">i</span> <span class="kw">as</span> <span class="ident">u128</span>);
    }

    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="attribute">#[<span class="ident">allow</span>(<span class="ident">clippy::collapsible_if</span>)]</span>
    <span class="kw">fn</span> <span class="ident">write</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">input</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>]) {
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">data</span> <span class="op">=</span> <span class="ident">input</span>;
        <span class="kw">let</span> <span class="ident">length</span> <span class="op">=</span> <span class="ident">data</span>.<span class="ident">len</span>() <span class="kw">as</span> <span class="ident">u64</span>;
        <span class="comment">//Needs to be an add rather than an xor because otherwise it could be canceled with carefully formed input.</span>
        <span class="self">self</span>.<span class="ident">buffer</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">buffer</span>.<span class="ident">wrapping_add</span>(<span class="ident">length</span>).<span class="ident">wrapping_mul</span>(<span class="ident">MULTIPLE</span>);
        <span class="comment">//A &#39;binary search&#39; on sizes reduces the number of comparisons.</span>
        <span class="kw">if</span> <span class="ident">data</span>.<span class="ident">len</span>() <span class="op">&gt;</span> <span class="number">8</span> {
            <span class="kw">if</span> <span class="ident">data</span>.<span class="ident">len</span>() <span class="op">&gt;</span> <span class="number">16</span> {
                <span class="kw">let</span> <span class="ident">tail</span> <span class="op">=</span> <span class="ident">data</span>.<span class="ident">read_last_u128</span>();
                <span class="self">self</span>.<span class="ident">large_update</span>(<span class="ident">tail</span>);
                <span class="kw">while</span> <span class="ident">data</span>.<span class="ident">len</span>() <span class="op">&gt;</span> <span class="number">16</span> {
                    <span class="kw">let</span> (<span class="ident">block</span>, <span class="ident">rest</span>) <span class="op">=</span> <span class="ident">data</span>.<span class="ident">read_u128</span>();
                    <span class="self">self</span>.<span class="ident">large_update</span>(<span class="ident">block</span>);
                    <span class="ident">data</span> <span class="op">=</span> <span class="ident">rest</span>;
                }
            } <span class="kw">else</span> {
                <span class="self">self</span>.<span class="ident">large_update</span>([<span class="ident">data</span>.<span class="ident">read_u64</span>().<span class="number">0</span>, <span class="ident">data</span>.<span class="ident">read_last_u64</span>()].<span class="ident">convert</span>());
            }
        } <span class="kw">else</span> {
            <span class="kw">let</span> <span class="ident">value</span> <span class="op">=</span> <span class="ident">read_small</span>(<span class="ident">data</span>);
            <span class="self">self</span>.<span class="ident">large_update</span>(<span class="ident">value</span>.<span class="ident">convert</span>());
        }
    }

    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;folded_multiply&quot;</span>)]</span>
    <span class="kw">fn</span> <span class="ident">finish</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">u64</span> {
        <span class="kw">let</span> <span class="ident">rot</span> <span class="op">=</span> (<span class="self">self</span>.<span class="ident">buffer</span> <span class="op">&amp;</span> <span class="number">63</span>) <span class="kw">as</span> <span class="ident">u32</span>;
        <span class="ident">folded_multiply</span>(<span class="self">self</span>.<span class="ident">buffer</span>, <span class="self">self</span>.<span class="ident">pad</span>).<span class="ident">rotate_left</span>(<span class="ident">rot</span>)
    }

    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">not</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;folded_multiply&quot;</span>))]</span>
    <span class="kw">fn</span> <span class="ident">finish</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">u64</span> {
        <span class="kw">let</span> <span class="ident">rot</span> <span class="op">=</span> (<span class="self">self</span>.<span class="ident">buffer</span> <span class="op">&amp;</span> <span class="number">63</span>) <span class="kw">as</span> <span class="ident">u32</span>;
        (<span class="self">self</span>.<span class="ident">buffer</span>.<span class="ident">wrapping_mul</span>(<span class="ident">MULTIPLE</span>) <span class="op">^</span> <span class="self">self</span>.<span class="ident">pad</span>).<span class="ident">rotate_left</span>(<span class="ident">rot</span>)
    }
}

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;specialize&quot;</span>)]</span>
<span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">struct</span> <span class="ident">AHasherU64</span> {
    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="ident">buffer</span>: <span class="ident">u64</span>,
    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="ident">pad</span>: <span class="ident">u64</span>,
}

<span class="doccomment">/// A specialized hasher for only primitives under 64 bits.</span>
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;specialize&quot;</span>)]</span>
<span class="kw">impl</span> <span class="ident">Hasher</span> <span class="kw">for</span> <span class="ident">AHasherU64</span> {
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">finish</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">u64</span> {
        <span class="kw">let</span> <span class="ident">rot</span> <span class="op">=</span> (<span class="self">self</span>.<span class="ident">pad</span> <span class="op">&amp;</span> <span class="number">63</span>) <span class="kw">as</span> <span class="ident">u32</span>;
        <span class="self">self</span>.<span class="ident">buffer</span>.<span class="ident">rotate_left</span>(<span class="ident">rot</span>)
    }

    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">write</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">_bytes</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>]) {
        <span class="macro">unreachable!</span>(<span class="string">&quot;Specialized hasher was called with a different type of object&quot;</span>)
    }

    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">write_u8</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">i</span>: <span class="ident">u8</span>) {
        <span class="self">self</span>.<span class="ident">write_u64</span>(<span class="ident">i</span> <span class="kw">as</span> <span class="ident">u64</span>);
    }

    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">write_u16</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">i</span>: <span class="ident">u16</span>) {
        <span class="self">self</span>.<span class="ident">write_u64</span>(<span class="ident">i</span> <span class="kw">as</span> <span class="ident">u64</span>);
    }

    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">write_u32</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">i</span>: <span class="ident">u32</span>) {
        <span class="self">self</span>.<span class="ident">write_u64</span>(<span class="ident">i</span> <span class="kw">as</span> <span class="ident">u64</span>);
    }

    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">write_u64</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">i</span>: <span class="ident">u64</span>) {
        <span class="self">self</span>.<span class="ident">buffer</span> <span class="op">=</span> <span class="ident">folded_multiply</span>(<span class="ident">i</span> <span class="op">^</span> <span class="self">self</span>.<span class="ident">buffer</span>, <span class="ident">MULTIPLE</span>);
    }

    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">write_u128</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">_i</span>: <span class="ident">u128</span>) {
        <span class="macro">unreachable!</span>(<span class="string">&quot;Specialized hasher was called with a different type of object&quot;</span>)
    }

    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">write_usize</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">_i</span>: <span class="ident">usize</span>) {
        <span class="macro">unreachable!</span>(<span class="string">&quot;Specialized hasher was called with a different type of object&quot;</span>)
    }
}

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;specialize&quot;</span>)]</span>
<span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">struct</span> <span class="ident">AHasherFixed</span>(<span class="kw">pub</span> <span class="ident">AHasher</span>);

<span class="doccomment">/// A specialized hasher for fixed size primitives larger than 64 bits.</span>
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;specialize&quot;</span>)]</span>
<span class="kw">impl</span> <span class="ident">Hasher</span> <span class="kw">for</span> <span class="ident">AHasherFixed</span> {
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">finish</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">u64</span> {
        <span class="self">self</span>.<span class="number">0</span>.<span class="ident">short_finish</span>()
    }

    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">write</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">bytes</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>]) {
        <span class="self">self</span>.<span class="number">0</span>.<span class="ident">write</span>(<span class="ident">bytes</span>)
    }

    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">write_u8</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">i</span>: <span class="ident">u8</span>) {
        <span class="self">self</span>.<span class="ident">write_u64</span>(<span class="ident">i</span> <span class="kw">as</span> <span class="ident">u64</span>);
    }

    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">write_u16</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">i</span>: <span class="ident">u16</span>) {
        <span class="self">self</span>.<span class="ident">write_u64</span>(<span class="ident">i</span> <span class="kw">as</span> <span class="ident">u64</span>);
    }

    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">write_u32</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">i</span>: <span class="ident">u32</span>) {
        <span class="self">self</span>.<span class="ident">write_u64</span>(<span class="ident">i</span> <span class="kw">as</span> <span class="ident">u64</span>);
    }

    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">write_u64</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">i</span>: <span class="ident">u64</span>) {
        <span class="self">self</span>.<span class="number">0</span>.<span class="ident">write_u64</span>(<span class="ident">i</span>);
    }

    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">write_u128</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">i</span>: <span class="ident">u128</span>) {
        <span class="self">self</span>.<span class="number">0</span>.<span class="ident">write_u128</span>(<span class="ident">i</span>);
    }

    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">write_usize</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">i</span>: <span class="ident">usize</span>) {
        <span class="self">self</span>.<span class="number">0</span>.<span class="ident">write_usize</span>(<span class="ident">i</span>);
    }
}

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;specialize&quot;</span>)]</span>
<span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">struct</span> <span class="ident">AHasherStr</span>(<span class="kw">pub</span> <span class="ident">AHasher</span>);

<span class="doccomment">/// A specialized hasher for a single string</span>
<span class="doccomment">/// Note that the other types don&#39;t panic because the hash impl for String tacks on an unneeded call. (As does vec)</span>
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;specialize&quot;</span>)]</span>
<span class="kw">impl</span> <span class="ident">Hasher</span> <span class="kw">for</span> <span class="ident">AHasherStr</span> {
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">finish</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">u64</span> {
        <span class="self">self</span>.<span class="number">0</span>.<span class="ident">finish</span>()
    }

    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">write</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">bytes</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>]) {
        <span class="kw">if</span> <span class="ident">bytes</span>.<span class="ident">len</span>() <span class="op">&gt;</span> <span class="number">8</span> {
            <span class="self">self</span>.<span class="number">0</span>.<span class="ident">write</span>(<span class="ident">bytes</span>)
        } <span class="kw">else</span> {
            <span class="kw">let</span> <span class="ident">value</span> <span class="op">=</span> <span class="ident">read_small</span>(<span class="ident">bytes</span>);
            <span class="self">self</span>.<span class="number">0</span>.<span class="ident">buffer</span> <span class="op">=</span> <span class="ident">folded_multiply</span>(<span class="ident">value</span>[<span class="number">0</span>] <span class="op">^</span> <span class="self">self</span>.<span class="number">0</span>.<span class="ident">buffer</span>,
                                           <span class="ident">value</span>[<span class="number">1</span>] <span class="op">^</span> <span class="self">self</span>.<span class="number">0</span>.<span class="ident">extra_keys</span>[<span class="number">1</span>]);
            <span class="self">self</span>.<span class="number">0</span>.<span class="ident">pad</span> <span class="op">=</span> <span class="self">self</span>.<span class="number">0</span>.<span class="ident">pad</span>.<span class="ident">wrapping_add</span>(<span class="ident">bytes</span>.<span class="ident">len</span>() <span class="kw">as</span> <span class="ident">u64</span>);
        }
    }

    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">write_u8</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">_i</span>: <span class="ident">u8</span>) {}

    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">write_u16</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">_i</span>: <span class="ident">u16</span>) {}

    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">write_u32</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">_i</span>: <span class="ident">u32</span>) {}

    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">write_u64</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">_i</span>: <span class="ident">u64</span>) {}

    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">write_u128</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">_i</span>: <span class="ident">u128</span>) {}

    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">write_usize</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">_i</span>: <span class="ident">usize</span>) {}
}

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">test</span>)]</span>
<span class="kw">mod</span> <span class="ident">tests</span> {
    <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::convert::Convert</span>;
    <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::fallback_hash</span>::<span class="kw-2">*</span>;

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">test_hash</span>() {
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">hasher</span> <span class="op">=</span> <span class="ident">AHasher::new_with_keys</span>(<span class="number">0</span>, <span class="number">0</span>);
        <span class="kw">let</span> <span class="ident">value</span>: <span class="ident">u64</span> <span class="op">=</span> <span class="number">1</span> <span class="op">&lt;</span><span class="op">&lt;</span> <span class="number">32</span>;
        <span class="ident">hasher</span>.<span class="ident">update</span>(<span class="ident">value</span>);
        <span class="kw">let</span> <span class="ident">result</span> <span class="op">=</span> <span class="ident">hasher</span>.<span class="ident">buffer</span>;
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">hasher</span> <span class="op">=</span> <span class="ident">AHasher::new_with_keys</span>(<span class="number">0</span>, <span class="number">0</span>);
        <span class="kw">let</span> <span class="ident">value2</span>: <span class="ident">u64</span> <span class="op">=</span> <span class="number">1</span>;
        <span class="ident">hasher</span>.<span class="ident">update</span>(<span class="ident">value2</span>);
        <span class="kw">let</span> <span class="ident">result2</span> <span class="op">=</span> <span class="ident">hasher</span>.<span class="ident">buffer</span>;
        <span class="kw">let</span> <span class="ident">result</span>: [<span class="ident">u8</span>; <span class="number">8</span>] <span class="op">=</span> <span class="ident">result</span>.<span class="ident">convert</span>();
        <span class="kw">let</span> <span class="ident">result2</span>: [<span class="ident">u8</span>; <span class="number">8</span>] <span class="op">=</span> <span class="ident">result2</span>.<span class="ident">convert</span>();
        <span class="macro">assert_ne!</span>(<span class="ident">hex::encode</span>(<span class="ident">result</span>), <span class="ident">hex::encode</span>(<span class="ident">result2</span>));
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">test_conversion</span>() {
        <span class="kw">let</span> <span class="ident">input</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>] <span class="op">=</span> <span class="string">&quot;dddddddd&quot;</span>.<span class="ident">as_bytes</span>();
        <span class="kw">let</span> <span class="ident">bytes</span>: <span class="ident">u64</span> <span class="op">=</span> <span class="macro">as_array!</span>(<span class="ident">input</span>, <span class="number">8</span>).<span class="ident">convert</span>();
        <span class="macro">assert_eq!</span>(<span class="ident">bytes</span>, <span class="number">0x6464646464646464</span>);
    }
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="ahash" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>